VERSION 5.00
Begin VB.Form SecureKey91Form 
   Caption         =   "Memory Banks Read/Write"
   ClientHeight    =   4575
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7665
   LinkTopic       =   "Form1"
   ScaleHeight     =   4575
   ScaleWidth      =   7665
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton WriteDS1991Button 
      Caption         =   "&Write the secure subkeys"
      Height          =   615
      Left            =   5760
      TabIndex        =   3
      Top             =   1920
      Width           =   1695
   End
   Begin VB.CommandButton SetAllDS1991Passwords 
      Caption         =   "&Find and set all DS1991s' passwords"
      Height          =   615
      Left            =   5760
      TabIndex        =   2
      Top             =   1080
      Width           =   1695
   End
   Begin VB.CommandButton ReadDS1991Button 
      Caption         =   "&Read the secure subkeys"
      Height          =   615
      Left            =   5760
      TabIndex        =   1
      Top             =   2760
      Width           =   1695
   End
   Begin VB.TextBox OneWireText 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3495
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   240
      Width           =   5295
   End
End
Attribute VB_Name = "SecureKey91Form"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'-------------------------------------------------------------------------
'Copyright (C) 2004 Dallas Semiconductor Corporation, All Rights Reserved.
'
'Permission is hereby granted, free of charge, to any person obtaining a
'copy of this software and associated documentation files (the "Software"),
'to deal in the Software without restriction, including without limitation
'the rights to use, copy, modify, merge, publish, distribute, sublicense,
'and/or sell copies of the Software, and to permit persons to whom the
'Software is furnished to do so, subject to the following conditions:
'
'The above copyright notice and this permission notice shall be included
'in all copies or substantial portions of the Software.
'
'THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
'OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
'MERCHANTABILITY,  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
'IN NO EVENT SHALL DALLAS SEMICONDUCTOR BE LIABLE FOR ANY CLAIM, DAMAGES
'OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
'ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
'OTHER DEALINGS IN THE SOFTWARE.
'
'Except as contained in this notice, the name of Dallas Semiconductor
'shall not be used except as stated in the Dallas Semiconductor
'Branding Policy.
'

Private Sub Form_Load()

On Error GoTo ErrorTrap

' make control line-feed string
CRLF = Chr(13) & Chr(10)
   
' get the 1-Wire access provider
Set access = New owapi.OneWireAccessProvider

' get the default adapter
Set adapter = access.getDefaultAdapter

' print that we got an adapter
OneWireText.Text = OneWireText.Text & CRLF & "Adapter: " & adapter.getAdapterName & " Port: " & adapter.getPortName & CRLF & CRLF

' set up variables for the password and id of the DS1991'
Set passwordBuf = New ByteArray
'For more info on ByteArray, please see
'the OWCOM Overview here:
'ftp://ftp.dalsemi.com/pub/auto_id/softdev/owdocs/Docs/OWCom/OWCOM_Overview.html
passwordBuf.setSize 8 ' set size to "password"
passwordBuf.setAt 0, Asc("p")
passwordBuf.setAt 1, Asc("a")
passwordBuf.setAt 2, Asc("s")
passwordBuf.setAt 3, Asc("s")
passwordBuf.setAt 4, Asc("w")
passwordBuf.setAt 5, Asc("o")
passwordBuf.setAt 6, Asc("r")
passwordBuf.setAt 7, Asc("d")

Set idBuf = New ByteArray
idBuf.setSize 8 ' set size to "DS1991id"
idBuf.setAt 0, Asc("d")
idBuf.setAt 1, Asc("s")
idBuf.setAt 2, Asc("1")
idBuf.setAt 3, Asc("9")
idBuf.setAt 4, Asc("9")
idBuf.setAt 5, Asc("1")
idBuf.setAt 6, Asc("i")
idBuf.setAt 7, Asc("d")

Set writeBuf = New ByteArray
writeBuf.setSize 11 ' set size to "TESTING 123" + 16 bytes of password and id
'For I = 0 To 15
'   writeBuf.setAt I, 0
'Next I
writeBuf.setAt 0, Asc("t")
writeBuf.setAt 1, Asc("e")
writeBuf.setAt 2, Asc("s")
writeBuf.setAt 3, Asc("t")
writeBuf.setAt 4, Asc("i")
writeBuf.setAt 5, Asc("n")
writeBuf.setAt 6, Asc("g")
writeBuf.setAt 7, Asc(" ")
writeBuf.setAt 8, Asc("1")
writeBuf.setAt 9, Asc("2")
writeBuf.setAt 10, Asc("3")

Set subkeyBuf = New ByteArray
subkeyBuf.setSize (64) ' set size to size of DS1991 subkey + 16 byte of id and password


Exit Sub

ErrorTrap:
    lastError = Err.Description
    OneWireText.Text = OneWireText.Text & CRLF & lastError & CRLF
    
End Sub


Private Sub ReadDS1991Button_Click()
 On Error GoTo ErrorTrap
' Clicking this button retrieves all 1-Wire parts found on a 1-Wire
' network and lists their addresses and prints out their subkeys if
' they are DS1991s.

Dim owd
Dim OneWireAddress
Dim I As Integer
Dim J As Integer

' get exclusive use of 1-Wire network
adapter.beginExclusive (True)

' clear any previous search restrictions
adapter.setSearchAllDevices
adapter.targetAllFamilies
adapter.setSpeed (adapter.SPEED_REGULAR)

' enumerate through all the 1-Wire devices found (with Java-style enumeration)
Set owd_enum = adapter.getAllDeviceContainers
OneWireText.Text = "1-Wire List:" & CRLF
OneWireText.Text = OneWireText.Text & "==========================" & CRLF
memoryBanksFound = 0
While owd_enum.hasMoreElements
   ' retrieve OneWireContainer
   Set owd = owd_enum.nextElement
   ' make OneWireContainer into specific OneWireContainer (i.e., OneWireContainer02)
   Set owd = owd.getMostSpecificComponent
   ' retrieve OneWireAddress
   OneWireText.Text = OneWireText.Text & CRLF ' adds a new blank line
   OneWireText.Text = OneWireText.Text & "Address = " & owd.getAddressAsString & CRLF
   ' check to see if 1-Wire device is a DS1991'
   If owd.getName = "DS1991" Then
      OneWireText.Text = OneWireText.Text & "Part Number: " & owd.getName & CRLF
      ' OneWireText.Text = OneWireText.Text & "Description: " & owd.getDescription & CRLF
      For I = 0 To 2  ' writes new password and id for each subkey'
         Set subkeyBuf = owd.readSubkey(I, passwordBuf)
         OneWireText.Text = OneWireText.Text & " Subkey " & I & ": "
         For J = 0 To 47
            ' to convert to ascii characters --> Chr(subkeyBuf.getAt(J))
            OneWireText.Text = OneWireText.Text & subkeyBuf.getAt(J) & " "
         Next J
         OneWireText.Text = OneWireText.Text & CRLF
      Next I
   End If

Wend ' End OneWireContainer enumeration loop


' end exclusive use of adapter
adapter.endExclusive

OneWireText.Text = OneWireText.Text & CRLF & CRLF
OneWireText.SelStart = Len(OneWireText.Text) ' make textbox autoscroll down

Exit Sub

ErrorTrap:
    lastError = Err.Description
    OneWireText.Text = OneWireText.Text & CRLF & lastError & CRLF
    adapter.endExclusive

End Sub

Private Sub SetAllDS1991Passwords_Click()
 On Error GoTo ErrorTrap
' Clicking this button retrieves all 1-Wire parts found on a 1-Wire
' network and lists their addresses and Memory Banks (if any).

Dim owd
Dim oldidBuf
Dim OneWireAddress
Dim I As Integer

' initialize subkeyBuf to zeroes
For I = 0 To 63
   subkeyBuf.setAt I, 0
Next I


' get exclusive use of 1-Wire network
adapter.beginExclusive (True)

' clear any previous search restrictions
adapter.setSearchAllDevices
adapter.targetAllFamilies
adapter.setSpeed (adapter.SPEED_REGULAR)

Set oldidBuf = New ByteArray
oldidBuf.setSize (8)
For I = 0 To 7
   oldidBuf.setAt I, 0
Next I

' enumerate through all the 1-Wire devices found (with Java-style enumeration)
Set owd_enum = adapter.getAllDeviceContainers
OneWireText.Text = "1-Wire List:" & CRLF
OneWireText.Text = OneWireText.Text & "==========================" & CRLF
memoryBanksFound = 0
While owd_enum.hasMoreElements
   ' retrieve OneWireContainer
   Set owd = owd_enum.nextElement
   ' make OneWireContainer into specific OneWireContainer (i.e., OneWireContainer02)
   Set owd = owd.getMostSpecificComponent
   ' retrieve OneWireAddress
   OneWireText.Text = OneWireText.Text & CRLF ' adds a new blank line
   OneWireText.Text = OneWireText.Text & "Address = " & owd.getAddressAsString & CRLF
   ' check to see if 1-Wire device is a DS1991'
   If owd.getName = "DS1991" Then
      OneWireText.Text = OneWireText.Text & "Part Number: " & owd.getName & CRLF
      ' OneWireText.Text = OneWireText.Text & "Description: " & owd.getDescription & CRLF
      For I = 0 To 2  ' writes new password and id for each subkey'
         ' first get the old id from reading the subkey
         Set subkeyBuf = owd.readSubkey(I, passwordBuf)
         For J = 0 To 7
            oldidBuf.setAt J, subkeyBuf.getAt(J)
         Next J
         owd.writePassword I, oldidBuf, idBuf, passwordBuf
      Next I
      OneWireText.Text = OneWireText.Text & "Writing new id and password: SUCCESS!" & CRLF
   End If

Wend ' End OneWireContainer enumeration loop


' end exclusive use of adapter
adapter.endExclusive

OneWireText.Text = OneWireText.Text & CRLF & CRLF
OneWireText.SelStart = Len(OneWireText.Text) ' make textbox autoscroll down

Exit Sub

ErrorTrap:
    lastError = Err.Description
    OneWireText.Text = OneWireText.Text & CRLF & lastError & CRLF
    adapter.endExclusive

End Sub

Private Sub WriteDS1991Button_Click()
 On Error GoTo ErrorTrap
' Clicking this button retrieves all 1-Wire parts found on a 1-Wire
' network and lists their addresses and Memory Banks (if any).

Dim owd
Dim OneWireAddress
Dim I As Integer

' get exclusive use of 1-Wire network
adapter.beginExclusive (True)

' clear any previous search restrictions
adapter.setSearchAllDevices
adapter.targetAllFamilies
adapter.setSpeed (adapter.SPEED_REGULAR)

' enumerate through all the 1-Wire devices found (with Java-style enumeration)
Set owd_enum = adapter.getAllDeviceContainers
OneWireText.Text = "1-Wire List:" & CRLF
OneWireText.Text = OneWireText.Text & "==========================" & CRLF
memoryBanksFound = 0
While owd_enum.hasMoreElements
   ' retrieve OneWireContainer
   Set owd = owd_enum.nextElement
   ' make OneWireContainer into specific OneWireContainer (i.e., OneWireContainer02)
   Set owd = owd.getMostSpecificComponent
   ' retrieve OneWireAddress
   OneWireText.Text = OneWireText.Text & CRLF ' adds a new blank line
   OneWireText.Text = OneWireText.Text & "Address = " & owd.getAddressAsString & CRLF
   ' check to see if 1-Wire device is a DS1991'
   If owd.getName = "DS1991" Then
      OneWireText.Text = OneWireText.Text & "Part Number: " & owd.getName & CRLF
      ' OneWireText.Text = OneWireText.Text & "Description: " & owd.getDescription & CRLF
      For I = 0 To 2  ' writes to subkey'
         Call owd.writeSubkey(I, 16, passwordBuf, writeBuf)
      Next I
      OneWireText.Text = OneWireText.Text & "Writing 'TESTING 123' to each subkey: SUCCESS!" & CRLF
   End If

Wend ' End OneWireContainer enumeration loop


' end exclusive use of adapter
adapter.endExclusive

OneWireText.Text = OneWireText.Text & CRLF & CRLF
OneWireText.SelStart = Len(OneWireText.Text) ' make textbox autoscroll down

Exit Sub

ErrorTrap:
    lastError = Err.Description
    OneWireText.Text = OneWireText.Text & CRLF & lastError & CRLF
    adapter.endExclusive

End Sub
